local name, private = ...

local locale = GetLocale()

local L = {
    enUS = {
        ["This achievement has been completed!"] = "This achievement has been completed!",
        ["No information available."] = "No information available.",
        ["Skill"] = "Skill",
        ["Race"] = "Race",
        ["Progress"] = "Progress",
        ["Artifact"] = "Artifact",
        ["Keystones"] = "Keystones",
        ["Travel frame"] = "Travel frame",
        ["Click to open the travel frame"] = "Click to open the travel frame",
        ["Item frame"] = "Item frame",
        ["Click to open the item frame"] = "Click to open the item frame",
        ["Crateables frame"] = "Crateables frame",
        ["Click to open a frame with all your crateable artifacts"] = "Click to open a frame with all your crateable artifacts",
        ["Page %d / %d"] = "Page %d / %d",
        ["Select a project"] = "Select a project",
        ["Select an item"] = "Select an item",
        ["Link?"] = "Link?",
        ["Project"] = "Project",
        ["Item"] = "Item",
        ["Link!"] = "Link!",
        ["Achievement frame"] = "Achievement frame",
        ["Click to open the achievement frame"] = "Click to open the achievement frame",
        ["Links frame"] = "Links frame",
        ["Click to open the links frame"] = "Click to open the links frame",
        ["Total progress"] = "Total progress",
        ["%d / %d artifacts completed."] = "%d / %d artifacts completed.",
        ["Click to see a list of incomplete artifacts."] = "Click to see a list of incomplete artifacts.",
        ["Right click to see all artifacts."] = "Right click to see all artifacts.",
        ["%d solves total."] = "%d solves total.",
        ["%d / %d fragments"] = "%d / %d fragments",
        ["Need %d more."] = "Need %d more.",
        ["Click to open artifact list."] = "Click to open artifact list.",
        ["Right click to solve."] = "Right click to solve.",
        ["RARE ARTIFACTS"] = "RARE ARTIFACTS",
        ["PRISTINE ARTIFACTS"] = "PRISTINE ARTIFACTS",
        ["COMMON ARTIFACTS"] = "COMMON ARTIFACTS",
        ["Completed"] = "Completed",
        ["Incomplete"] = "Incomplete",
        ["completed"] = "completed",
        ["You have not yet learned archaeology."] = "You have not yet learned archaeology.",
    },
}

local d = private.objects.list() -- List of strings already displayed for debugging

local metaL = {

}

function metaL.__call(self, ...)
    local arg = ...
    if self[locale] then
        if self[locale][arg] then
            return self[locale][arg]
        end
    end
    if self.enUS[arg] then
        if not d:has(arg) then
            d:add(arg)
            private:debug("String not found for current locale: " .. arg)
        end
        return self.enUS[arg]
    end
    if not d:has(arg) then
        d:add(arg)
        private:debug("String not found for current locale or enUS: " .. arg)
    end
    return arg
end

setmetatable(L, metaL)

private.L = L